<script setup lang="ts">
import { ref, onMounted } from "vue";
import type { QTableProps } from "quasar";
import { useQuasar } from "quasar";
import { useRouter } from "vue-router";

import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";
import { useKPIDataStore } from "@/modules/01_masterdata/stores/KPIStore";
import { checkPermission } from "@/utils/permissions";
import { usePagination } from "@/composables/usePagination";


import type { DataOption } from "@/modules/01_masterdata/interface/index/Main";

import type { ResDataCapacity } from "@/modules/01_masterdata/interface/response/Main";

import CompetencyTotal from "@/modules/01_masterdata/components/competency/Summary.vue";

const $q = useQuasar();
const mixin = useCounterMixin();
const { dialogRemove, messageError, showLoader, hideLoader, success } = mixin;
const { pagination, params, onRequest, checkAndUpdatePage } = usePagination(
  "",
  fetchList
);

const store = useKPIDataStore();
const router = useRouter();

const columns = ref<QTableProps["columns"]>([
  {
    name: "name",
    align: "left",
    label: "ชื่อสมรรถนะ",
    sortable: true,
    field: "name",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);
const visibleColumns = ref<string[]>(["name"]);

const rows = ref<ResDataCapacity[]>([]); // ข้อมูลสมรรถนะ
const keyword = ref<string>(""); // คำค้นหา
const competencyTypeOp = ref<DataOption[]>([
  {
    id: "HEAD",
    name: "สมรรถนะหลัก",
  },
  {
    id: "GROUP",
    name: "สมรรถนะประจำกลุ่มงาน",
  },
  {
    id: "EXECUTIVE",
    name: "สมรรถนะประจำผู้บริหารกรุงเทพมหานคร",
  },
  {
    id: "DIRECTOR",
    name: "สมรรถนะเฉพาะสำหรับตำแหน่ง ผอ.เขต ผช.ผอ.เขต และหัวหน้าฝ่ายในสังกัด สนง.เขต",
  },
  {
    id: "INSPECTOR",
    name: "สมรรถนะเฉพาะสำหรับตำแหน่งผู้ตรวจราชการ กทม. และผู้ตรวจราชการ",
  },
]); // ประเภทสมรรถนะ

/** ฟังก์ชันดึงข้อมูลรายการสมรรถนะ */
async function fetchList() {
  showLoader();
  const queryParams = {
    ...params.value,
    keyword: keyword.value.trim(),
    type: store.competencyTypeVal,
  };
  await http
    .get(config.API.kpiCapacity + "/edit", { params: queryParams })
    .then(async (res) => {
      const result = res.data.result;
      pagination.value.rowsNumber = result.total;
      rows.value = result.data;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันไปหน้าแก้ไขสมรรถนะ
 * @param id รหัสสมรรถนะที่ต้องการแก้ไข
 */
async function onViewDetail(id: string) {
  router.push(`/masterdata/competency/${id}`);
}

/**
 * ฟังก์ชันดูรายละเอียดสมรรถนะ
 * @param id รหัสสมรรถนะที่ต้องการดูรายละเอียด
 */
async function onViewDetailPage(id: string) {
  router.push(`/masterdata/competency-detail/${id}`);
}

/**
 * ฟังก์ชันลบข้อมูลสมรรถนะ
 * @param id รหัสสมรรถนะที่ต้องการลบ
 */
function deleteData(id: string) {
  dialogRemove($q, async () => {
    showLoader();
    await http
      .delete(config.API.kpiCapacity + `/${id}`)
      .then(async () => {
        await checkAndUpdatePage(rows.value.length);
        await fetchList();
        success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/** เปลี่ยนเป็นหน้าเพิ่มข้อมูล */
function onAdd() {
  router.push(`/masterdata/competency/add`);
}

function fetchNewList() {
  pagination.value.page = 1;
  fetchList();
}

onMounted(() => {
  fetchList();
});
</script>

<template>
  <div class="row">
    <div class="col-12">
      <CompetencyTotal />
    </div>
  </div>
  <q-toolbar style="padding: 0">
    <q-select
      v-model="store.competencyTypeVal"
      outlined
      label="ประเภทสมรรถนะ"
      dense
      option-label="name"
      option-value="id"
      :options="competencyTypeOp"
      style="min-width: 200px"
      emit-value
      map-options
      @update:model-value="fetchNewList"
    />
    <q-btn
      v-if="checkPermission($route)?.attrIsCreate"
      flat
      round
      color="primary"
      icon="add"
      @click="onAdd()"
    >
      <q-tooltip> เพิ่มข้อมูล </q-tooltip>
    </q-btn>
    <q-space />
    <div class="row q-gutter-sm">
      <q-input
        outlined
        dense
        v-model="keyword"
        label="ค้นหา"
        @keyup.enter="fetchNewList()"
      >
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-select
        v-model="visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        style="min-width: 140px"
      />
    </div>
  </q-toolbar>

  <p-table
    ref="table"
    :columns="columns"
    :rows="rows"
    row-key="id"
    flat
    bordered
    :paging="true"
    dense
    :rows-per-page-options="[10, 25, 50, 100]"
    class="custom-header-table"
    :visible-columns="visibleColumns"
    @request="onRequest"
    v-model:pagination="pagination"
  >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th auto-width />
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
      </q-tr>
    </template>
    <template v-slot:body="props">
      <q-tr :props="props">
        <q-td auto-width>
          <q-btn
            v-if="checkPermission($route)?.attrIsGet"
            color="info"
            flat
            dense
            round
            icon="mdi-eye"
            clickable
            @click.stop="onViewDetailPage(props.row.id)"
            v-close-popup
          >
            <q-tooltip>รายละเอียด</q-tooltip>
          </q-btn>
          <q-btn
            v-if="
              checkPermission($route)?.attrIsGet &&
              checkPermission($route)?.attrIsUpdate
            "
            color="edit"
            flat
            dense
            round
            icon="edit"
            clickable
            @click.stop="onViewDetail(props.row.id)"
            v-close-popup
          >
            <q-tooltip>แก้ไขข้อมูล</q-tooltip>
          </q-btn>
          <q-btn
            v-if="checkPermission($route)?.attrIsDelete"
            color="red"
            flat
            dense
            round
            icon="mdi-delete"
            clickable
            @click.stop="deleteData(props.row.id)"
            v-close-popup
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn>
        </q-td>
        <q-td v-for="col in props.cols" :key="col.id">
          {{ col.value }}
        </q-td>
      </q-tr>
    </template>
  </p-table>
</template>
